Linux常用Shell指令碼珍藏
我們在運維中,尤其是linux運維,都知道指令碼的重要性,指令碼會讓我們的 運維事半功倍,所以學會寫指令碼是我們每個linux運維必須學會的一門功課,這裡收藏linux運維常用的指令碼。如何學好指令碼,最關鍵的是就是大量的練習 和實踐。根據以下指令碼我們可以拓展,這樣我們提高的很快!舉一反三!
1.用Shell程式設計,判斷一檔案是不是字元裝置檔案,如果是將其拷貝到 /dev 目錄下。
參考程式:
- #!/bin/sh
- FILENAME=
- echo “Input file name:”
- read FILENAME
- if [ -c "$FILENAME" ]
- then
- cp $FILENAME /dev
- fi
2.設計一個shell程式,新增一個新組為class1,然後新增屬於這個組的30個使用者,使用者名稱的形式為stdxx,其中xx從01到30。
參考答案:
- #!/bin/sh
- i=1
- groupadd class1
- while [ $i -le 30 ]
- do
- if [ $i -le 9 ] ;then
- USERNAME=stu0${i}
- else
- USERNAME=stu${i}
- fi
- useradd $USERNAME
- mkdir /home/$USERNAME
- chown -R $USERNAME /home/$USERNAME
- chgrp -R class1 /home/$USERNAME
- i=$(($i+1))
- done
3.編寫shell程式,實現自動刪除50個賬號的功能。賬號名為stud1至stud50。
參考程式:
- #!/bin/sh
- i=1
- while [ $i -le 50 ]
- do
- userdel -r stud${i}
- i=$(($i+1 ))
- done
4.某系統管理員需每天做一定的重複工作,請按照下列要求,編制一個解決方案: (1)在下午4 :50刪除/abc目錄下的全部子目錄和全部檔案; (2)從早8:00~下午6:00每小時讀取/xyz目錄下x1檔案中每行第一個域的全部資料加入到/backup目錄下的bak01.txt檔案內; (3)每逢星期一下午5:50將/data目錄下的所有目錄和檔案歸檔並壓縮為檔案:backup.tar.gz; (4)在下午5:55將IDE介面的CD-ROM解除安裝(假設:CD-ROM的裝置名為hdc); (5)在早晨8:00前開機後啟動。
參考答案: 解決方案: (1)用vi建立編輯一個名為prgx的crontab檔案; (2)prgx檔案的內容:
- 50 16 * * * rm -r /abc/*
- 0 8-18/1 * * * cut -f1 /xyz/x1 >;>; /backup/bak01.txt
- 50 17 * * * tar zcvf backup.tar.gz /data
- 55 17 * * * umount /dev/hdc
(3)由超級使用者登入,用crontab執行 prgx檔案中的內容: [email protected]:#crontab prgx;在每日早晨8:00之前開機後即可自動啟動crontab。
5.設計一個shell程式,在每月第一天備份並壓縮/etc目錄的所有內容,存放在/root/bak目錄裡,且檔名為如下形式yymmdd_etc,yy為年,mm為月,dd為日。Shell程式fileback存放在/usr/bin目錄下。
參考答案: (1)編寫shell程式fileback:
- #!/bin/sh
- DIRNAME=`ls /root | grep bak`
- if [ -z "$DIRNAME" ] ; then
- mkdir /root/bak
- cd /root/bak
- fi
- YY=`date +%y`
- MM=`date +%m`
- DD=`date +%d`
- BACKETC=$YY$MM$DD_etc.tar.gz
- tar zcvf $BACKETC /etc
- echo “fileback finished!”
(2)編寫任務定時器:
- echo “0 0 1 * * /bin/sh /usr/bin/fileback” >; /root/etcbakcron
- crontab /root/etcbakcron
- 或使用crontab -e 命令新增定時任務:
- 0 1 * * * /bin/sh /usr/bin/fileback
6.有一普通使用者想在每週日凌晨零點零分定期備份/user/backup到/tmp目錄下,該使用者應如何做?
參考答案:
(1)第一種方法:
- 使用者應使用crontab –e 命令建立crontab檔案。格式如下:
- 0 0 * * sun cp –r /user/backup /tmp
(2)第二種方法: 使用者先在自己目錄下新建檔案file,檔案內容如下:
- 0 * * sun cp –r /user/backup /tmp
然後執行 crontab file 使生效。
7.設計一個Shell程式,在/userdata目錄下建立50個目錄,即user1~user50,並設定每個目錄的許可權,其中其他使用者的許可權為:讀;檔案所有者的許可權為:讀、寫、執行;檔案所有者所在組的許可權為:讀、執行。
參考答案: 建立程式 Pro16如下:
- #!/bin/sh
- i=1
- while [ i -le 50 ]
- do
- if [ -d /userdata ];then
- mkdir -p /userdata/user$i
- chmod 754 /userdata/user$i
- echo “user$i”
- let “i = i + 1″ (或i=$(($i+1))
- else
- mkdir /userdata
- mkdir -p /userdata/user$i
- chmod 754 /userdata/user$i
- echo “user$i”
- let “i = i + 1″ (或i=$(($i+1))
- fi
- done
8、mysql備份例項,自動備份mysql,並刪除30天前的備份檔案
- #!/bin/sh
- #auto backup mysql
- #wugk 2012-07-14
- #PATH DEFINE
- BAKDIR=/data/backup/mysql/`date +%Y-%m-%d`
- MYSQLDB=www
- MYSQLPW=backup
- MYSQLUSR=backup
- if[ $UID -ne 0 ];then
- echo This script must use administrator or root user ,please exit!
- sleep 2
- exit 0
- fi
- if[ ! -d $BAKDIR ];then
- mkdir -p $BAKDIR
- else
- echo This is $BAKDIR exists ,please exit ….
- sleep 2
- exit
- fi
- ###mysqldump backup mysql
- /usr/bin/mysqldump -u$MYSQLUSR -p$MYSQLPW -d $MYSQLDB >/data/backup/mysql/`date +%Y-%m-%d`/www_db.sql
- cd $BAKDIR ; tar -czf www_mysql_db.tar.gz *.sql
- cd $BAKDIR ;find . -name “*.sql” |xargs rm -rf[ $? -eq 0 ]&&echo “This `date +%Y-%m-%d` RESIN BACKUP is SUCCESS”
- cd /data/backup/mysql/ ;find . -mtime +30 |xargs rm -rf
9、自動安裝Nginx指令碼,採用case方式,選擇方式,也可以根據實際需求改成自己想要的指令碼
- #!/bin/sh
- ###nginx install shell
- ###wugk 2012-07-14
- ###PATH DEFINE
- SOFT_PATH=/data/soft/
- NGINX_FILE=nginx-1.2.0.tar.gz
- DOWN_PATH=http://nginx.org/download/
- if[ $UID -ne 0 ];then
- echo This script must use administrator or root user ,please exit!
- sleep 2
- exit 0
- fi
- if[ ! -d $SOFT_PATH ];then
- mkdir -p $SOFT_PATH
- fi
- download ()
- {
- cd $SOFT_PATH ;wget $DOWN_PATH/$NGINX_FILE
- }
- install ()
- {
- yum install pcre-devel -y
- cd $SOFT_PATH ;tar xzf $NGINX_FILE ;cd nginx-1.2.0/ &&./configure –prefix=/usr/local/nginx/ –with-http_stub_status_module –with-http_ssl_module
- [ $? -eq 0 ]&&make &&make install
- }
- start ()
- {
- lsof -i :80[ $? -ne 0 ]&&/usr/local/nginx/sbin/nginx
- }
- stop ()
- {
- ps -ef |grep nginx |grep -v grep |awk ‘{print $2}’|xargs kill -9
- }
- exit ()
- {
- echo $? ;exit
- }
- ###case menu #####
- case $1 in
- download )
- download
- ;;
- install )
- install
- ;;
- start )
- start
- ;;
- stop )
- stop
- ;;
- * )
- echo “USAGE:$0 {download or install or start or stop}”
- exit
- esac
10、批量解壓tar指令碼,批量解壓zip並且建立當前目錄。
- #!/bin/sh
- PATH1=/tmp/images
- PATH2=/usr/www/images
- for i in `ls ${PATH1}/*`
- do
- tar xvf $i -C $PATH2
- done
這個指令碼是針對所有tar檔案在一個目錄,但是實際情況中,有可能在下級或者更深的目錄,我們可以使用find查詢
- #!/bin/sh
- PATH1=/tmp/images
- PATH2=/usr/www/images
- for i in `find $PATH1 -name ”*.tar” `
- do
- tar xvf $i -C $PATH2
- done
如何是zip檔案,例如123189.zip 132342.zip 等等批量檔案,預設unzip直接解壓不帶自身目錄,意思是解壓123189.zip完當前目錄就是圖片,不能建立123189目錄下並解壓,可以用shell指令碼實現
- #!/bin/sh
- PATH1=/tmp/images
- PATH2=/usr/www/images
- cd $PATH1
- for i in `find . -name ”*.zip”|awk -F. {print $2} `
- do
- mkdir -p PATH2$i
- unzip -o .$i.zip -d PATH2$i
- done
ssh 批量上傳檔案
上傳檔案大多數用的是ftp,但是用ftp有一點不好,就是本地和遠端的目錄要對應,這樣就要在多個目錄下去切換,這樣挺麻煩的,如果不注意的話,很有可能傳錯。所以想了個辦法利用scp來批量上傳檔案或者目錄。
一,scp上傳不要輸入密碼
如果要用scp來上傳檔案,第一步就要去掉scp上傳時要輸入密碼。要不然就沒辦法批量上傳了。具體請參考:
二,ssh批量上傳指令碼
1,要上傳的檔案列表放到一個test檔案中
- [email protected]:/home/zhangy# cat test
- /home/zhangy/test/aaa
- /home/zhangy/test/nginx.conf
- /home/zhangy/test/test.sql
- /home/zhangy/test/pa.txt
- /home/zhangy/test/password
上面就要上傳的檔案。
2,批量上傳的指令碼
vim file_upload.sh
- #!/bin/sh
- DATE=`date +%Y_%m_%d_%H`
- if [ $1 ]
- then
- for file in $(sed '/^$/d' $1) //去掉空行
- do
- if [ -f $file ] //普通檔案
- then
- res=`scp $file $2:$file` //上傳檔案
- if [ -z $res ] //上傳成功
- then
- echo $file >> ${DATE}_upload.log //上傳成功的日誌
- fi
- elif [ -d $file ] //目錄
- then
- res=`scp -r $file $2:$file`
- if [ -z $res ]
- then
- echo $file >> ${DATE}_upload.log
- fi
- fi
- done
- else
- echo "no file" >> ${DATE}_error.log
- fi
上傳成功後,返回的是一個空行,上傳不成功,什麼都不返回
3,上傳的格式
- ./file_upload.sh test 192.168.1.13
test是上傳列表檔案,192.168.1.13檔案要傳到的地方。
1. 轉換檔案大小寫:
A script to convert the specified filenames to lower case.
- #!/bin/sh
- # lowerit
- # convert all file names in the current directory to lower case
- # only operates on plain files--does not change the name of directories
- # will ask for verification before overwriting an existing file
- for x in `ls`
- do
- if [ ! -f $x ]; then
- continue
- fi
- lc=`echo $x | tr '[A-Z]' '[a-z]'`
- if [ $lc != $x ]; then
- mv -i $x $lc
- fi
- done
or
- if test $# = 0
- then
- echo "Usage $0: <files>" 1>&2
- exit 1
- fi
- for filename in "[email protected]"
- do
- new_filename=`echo "$filename" | tr A-Z a-z`
- test "$filename" = "$new_filename" && continue
- if test -r "$new_filename"
- then
- echo "$0: $new_filename exists" 1>&2
- elif test -e "$filename"
- then
- mv "$filename" "$new_filename"
- else
- echo "$0: $filename not found" 1>&2
- fi
- done
2. 看網站 Watch a Website
A script to repeated download a webpage until it matches a regex then notify an e-mail address.
For example to get e-mail when Kesha tickets (not for yourself of course) go on sale you might run:
- % watch_website.sh http://ticketek.com.au/ 'Ke[sS$]+ha' [email protected]
- repeat_seconds=300 #check every 5 minutes
- if test $# = 3
- then
- url=$1
- regexp=$2
- email_address=$3
- else
- echo "Usage: $0 <url> <regex>" 1>&2
- exit 1
- fi
- while true
- do
- if wget -O- -q "$url"|egrep "$regexp" >/dev/null
- then
- echo "Generated by $0" | mail -s "$url now matches $regexp" $email_address
- exit 0
- fi
- sleep $repeat_seconds
- done
3. 轉GIF到PNG convert GIF files to PNG
This scripts converts GIF files to PNG files via the intermediate PPM format.
- if [ $# -eq 0 ]
- then
- echo "Usage: $0 files..." 1>&2
- exit 1
- fi
- if ! type giftopnm 2>/dev/null
- then
- echo "$0: conversion tool giftopnm not found " 1>&2
- exit 1
- fi
- # missing "in ..." defaults to in "[email protected]"
- for f
- do
- case "$f" in
- *.gif)
- # OK, do nothing
- ;;
- *)
- echo "gif2png: skipping $f, not GIF"
- continue
- ;;
- esac
- dir=`dirname "$f"`
- base=`basename "$f" .gif`
- result="$dir/$base.png"
- giftopnm "$f" | pnmtopng > $result && echo "wrote $result"
- done
4. 計數 Counting
A utility script to print the sub-range of integers specified by its arguments.
Useful to use on the command line or from other scripts
- if test $# = 1
- then
- start=1
- finish=$1
- elif test $# = 2
- then
- start=$1
- finish=$2
- else
- echo "Usage: $0 <start> <finish>" 1>&2
- exit 1
- fi
- for argument in "[email protected]"
- do
- if echo "$argument"|egrep -v '^-?[0-9]+$' >/dev/null
- then
- echo "$0: argument '$argument' is not an integer" 1>&2
- exit 1
- fi
- done
- number=$start
- while test $number -le $finish
- do
- echo $number
- number=`expr $number + 1` # or number=$(($number + 1))
- done
5. 字頻率 Word Frequency
Count the number of time each different word occurs in the files given as arguments.
- sed 's/ /\n/g' "[email protected]"| # convert to one word per line
- tr A-Z a-z| # map uppercase to lower case
- sed "s/[^a-z']//g"| # remove all characters except a-z and '
- egrep -v '^$'| # remove empty lines
- sort| # place words in alphabetical order
- uniq -c| # use uniq to count how many times each word occurs
- sort -n # order words in frequency of occurrance
For example
- % cd /home/cs2041/public_html/lec/shell/examples
- % ./word_frequency.sh dracula.txt|tail
- 2124 it
- 2440 that
- 2486 in
- 2549 he
- 2911 a
- 3600 of
- 4448 to
- 4740 i
- 5833 and
- 7843 the
6. Finding
Search $PATH for the specified programs
- if test $# = 0
- then
- echo "Usage $0: <program>" 1>&2
- exit 1
- fi
- for program in "[email protected]"
- do
- program_found=''
- for directory in `echo "$PATH" | tr ':' ' '`
- do
- f="$directory/$program"
- if test -x "$f"
- then
- ls -ld "$f"
- program_found=1
- fi
- done
- if test -z $program_found
- then
- echo "$program not found"
- fi
- done
Alternative implementation using while, and a cute use of grep and ||
- if test $# = 0
- then
- echo "Usage $0: <program>" 1>&2
- exit 1
- fi
- for program in "[email protected]"
- do
- echo "$PATH"|
- tr ':' '\n'|
- while read directory
- do
- f="$directory/$program"
- if test -x "$f"
- then
- ls -ld "$f"
- fi
- done|
- egrep '.' || echo "$program not found"
- done
And another implementation using while, and a cute use of grep and ||
- if test $# = 0
- then
- echo "Usage $0: <program>" 1>&2
- exit 1
- fi
- for program in "[email protected]"
- do
- n_path_components=`echo $PATH|tr -d -c :|wc -c`
- index=1
- while test $index -le $n_path_components
- do
- directory=`echo "$PATH"|cut -d: -f$index`
- f="$directory/$program"
- if test -x "$f"
- then
- ls -ld "$f"
- program_found=1
- fi
- index=`expr $index + 1`
- done
- test -n $program_found || echo "$program not found"
- done